"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MyUpload = void 0;

var _vue = require("vue");

var _core = require("@vueuse/core");

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var MyUpload = (0, _vue.defineComponent)({
  props: {
    value: Array,
    action: String,
    data: Object,
    size: {
      type: Number,
      "default": 5
    }
  },
  setup: function setup(props, _ref) {
    var emit = _ref.emit;
    var uploaddata = (0, _vue.ref)({});
    var previewVisible = (0, _vue.ref)(false);
    var previewImage = (0, _vue.ref)('');
    var selected = (0, _core.useVModel)(props, 'value', emit);

    var handlePreview = /*#__PURE__*/function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(file) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (file.url) {
                  previewImage.value = file.url;
                  previewVisible.value = true;
                }

              case 1:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function handlePreview(_x) {
        return _ref2.apply(this, arguments);
      };
    }();

    var beforeUploadFun = function beforeUploadFun(file) {
      var index = file.name.lastIndexOf('.');
      var filename = new Date().getTime() + '.' + file.name.substring(index + 1, file.name.length);
      uploaddata.value.key = 'uploads/' + filename;
      uploaddata.value.name = filename;
    };

    var handleChange = function handleChange(v) {
      var arr = selected.value;
      var update = uploaddata.value;
      console.log(v, uploaddata.value, update, '上传');
      selected.value = [].concat(_toConsumableArray(arr), [{
        uid: new Date().getTime(),
        url: update.host + '/' + update.key,
        name: update.name
      }]); // if (v.event) {
      //   if (v.event.percent == 100) {
      //     selected.value?.push({
      //       uid: new Date().getTime(),
      //       url: uploaddata.value.host + '/' + uploaddata.value.key,
      //       name: uploaddata.value.name,
      //     });
      //     console.log(selected.value);
      //   }
      // }
    };

    var heanleRemove = function heanleRemove(file) {
      var _a;

      (_a = selected.value) === null || _a === void 0 ? void 0 : _a.forEach(function (res, index) {
        var _a;

        if (res.uid == file.uid) {
          (_a = selected.value) === null || _a === void 0 ? void 0 : _a.splice(index, 1);
        }
      });
    };

    (0, _vue.watchEffect)(function () {
      uploaddata.value = props.data;
    });
    return function () {
      return (0, _vue.createVNode)(_vue.Fragment, null, [(0, _vue.createVNode)("div", {
        "class": "upload_cont"
      }, [(0, _vue.createVNode)((0, _vue.resolveComponent)("a-upload"), {
        "action": props.action,
        "data": uploaddata.value,
        "file-list": selected.value,
        "list-type": "picture-card",
        "beforeUpload": beforeUploadFun,
        "onPreview": handlePreview,
        "onChange": handleChange,
        "remove": heanleRemove
      }, {
        "default": function _default() {
          return [selected.value.length < props.size ? (0, _vue.createVNode)("div", {
            "style": "font-size:30px;"
          }, [(0, _vue.createTextVNode)("+")]) : ''];
        }
      })]), (0, _vue.createVNode)((0, _vue.resolveComponent)("a-modal"), {
        "visible": previewVisible.value,
        "footer": "",
        "onCancel": function onCancel() {
          previewVisible.value = false;
        }
      }, {
        "default": function _default() {
          return [(0, _vue.createVNode)("img", {
            "alt": "example",
            "style": "width: 100%",
            "src": previewImage.value
          }, null)];
        }
      })]);
    };
  }
});
exports.MyUpload = MyUpload;